# Modified JavaFXML Maven archetype 
This archetype has been derived from https://github.com/openjfx/javafx-maven-archetypes /
https://mvnrepository.com/artifact/org.openjfx/javafx-archetype-fxml. The following features have been added:

- FXML support https://docs.oracle.com/javafx/2/get_started/fxml_tutorial.htm
- current Log4j and Junit.

## Hosting
The archetype is available from 
https://maven.mi.hdm-stuttgart.de/nexus/#browse/browse:mi-maven:de%2Fhdm_stuttgart%2Fmi%2Fmi-maven-archetype-javafxml.

## Getting started

<!-- language-all: bash -->
1. Follow https://freedocs.mi.hdm-stuttgart.de/sd1_sect_mavenCli.html#sd1_fig_mavenMiRepo to configure the above MI  
   Maven Nexus Maven repository server for CLI usage in your `~/.m2/settings.xml` configuration.
1. Choose your desired archetype version and create a new project by executing:

       mvn archetype:generate -DarchetypeCatalog=local -DarchetypeGroupId=de.hdm-stuttgart.mi \
       -DarchetypeArtifactId=mi-maven-archetype-javafxml -DarchetypeVersion=21.0.1 \
       -DgroupId=de.mi.hdm_stuttgart -DartifactId=hellojavafx -DinteractiveMode=false

1. Execute `mvn javafx:run`. You should see a GUI window popping up. Enter input and see corresponding log entries
   in your underlying shell. In case you favour the Idea GUI over terminal commands you may click
   `Run 🠖 Edit Configurations`. Then add a Maven run configuration entering `javafx:run` in the Run / Command line
   textfield mimicking the previous `mvn javafx:run` terminal command.
1. Optional: Working with Idea follow
   https://freedocs.mi.hdm-stuttgart.de/sd1_sect_idea.html#sd1_fig_mavenIdeaArchetypeCatalogPlugin to configure
   the MI Maven Nexus Maven repository server in your IDE as well. This allows for using the current archetype for
   creating new JavaFXML projects by virtue of Idea's GUI. 
   > Note: You still need `~/.m2/settings.xml` as a prerequisite.


 
